unit Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Ani,
  FMX.ListBox, FMX.Objects;

type
  TForm3 = class(TForm)
    Button1: TButton;
    cbbInterpolation: TComboBox;
    Panel1: TPanel;
    Circle1: TCircle;
    cbbAnimation: TComboBox;
    FloatAnimation1: TFloatAnimation;
    rbTFloatAnimation: TRadioButton;
    rbAnimationFloat: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FLastValue: Single;
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

uses
  System.TypInfo;

{$R *.fmx}

procedure TForm3.FormCreate(Sender: TObject);
var
  Animation: TAnimationType;
  Interpolation: TInterpolationType;
begin
  Circle1.Position.X := 0;
  Circle1.Position.Y := (Panel1.Height - Circle1.Height) / 2;

  FLastValue := Panel1.Width - Circle1.Width;

  for Animation in [Low(TAnimationType)..High(TAnimationType)] do
    cbbAnimation.Items.AddObject(GetEnumName(TypeInfo(TAnimationType), Ord(Animation)), TObject(Animation));
  cbbAnimation.ItemIndex := 0;

  for Interpolation in [Low(TInterpolationType)..High(TInterpolationType)] do
    cbbInterpolation.Items.AddObject(GetEnumName(TypeInfo(TInterpolationType), Ord(Interpolation)), TObject(Interpolation));
  cbbInterpolation.ItemIndex := 0;
end;

procedure TForm3.Button1Click(Sender: TObject);
begin
  if rbTFloatAnimation.IsChecked then
  begin
    FloatAnimation1.PropertyName := 'Position.X';
    FloatAnimation1.StartValue := 0;
    FloatAnimation1.StopValue := FLastValue;
    FloatAnimation1.Duration := 1;
    FloatAnimation1.AnimationType := TAnimationType(cbbAnimation.Items.Objects[cbbAnimation.ItemIndex]);
    FloatAnimation1.Interpolation := TInterpolationType(cbbInterpolation.Items.Objects[cbbInterpolation.ItemIndex]);
    FloatAnimation1.Start;
  end
  else
  begin
    Circle1.Position.X := 0;
    Circle1.AnimateFloat(
        'Position.X',
        FLastValue,
        1,
        TAnimationType(cbbAnimation.Items.Objects[cbbAnimation.ItemIndex]),
        TInterpolationType(cbbInterpolation.Items.Objects[cbbInterpolation.ItemIndex])
    );
  end;
end;

end.
